package cmdMisc

import (
    "io/ioutil"
    u "nexus-client/utils"
)

type Ls struct {
    Name string
}

func (cmd *Ls)GetName() string {
    return cmd.Name
}

func (cmd *Ls)GetDesc() []string {
    return []string{"List files in the specified dir or in the current dir if no argument is specified."}
}

func (cmd *Ls)PrintUsage() {
    for _, desc := range cmd.GetDesc() {
        u.PrintlnErr(desc)
    }
    u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
    u.PrintlnErr("USAGE: ",cmd.GetName(), " [dir]")
    u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
    u.PrintlnErr("List files in the specified dir or in the current dir if no argument is specified.")
}

func (cmd *Ls)Run(args []string) int {
    argc := len(args)
    if argc == 0 {
        cmd.listDir(".")
    } else if argc == 1 {
        cmd.listDir(args[0])
    } else {
        cmd.PrintUsage()
        return 1
    }
    return 0
}

// List files in the specified directory.
func (cmd *Ls)listDir(dir string) {
    fis, err := ioutil.ReadDir(dir)
    if err != nil {
        u.PrintlnErr("Failed reading \""+dir+"\" directory: "+err.Error())
        return
    }

    for _, info := range fis {
        filename := info.Name()
        if info.IsDir() {
            filename = filename+"/"
        }
        u.Println(filename)
    }
}
